<template lang="pug">
  v-list: v-row(no-gutters)
    v-col(cols=12, v-if="error")
      v-list-item(to="/")
        v-list-item-icon
          v-icon mdi-chevron-left
        v-list-item-content
          v-list-item-title Not found
    
    v-col(cols=12, v-else-if="path!='/'")
      v-list-item(:to="back")
        v-list-item-icon
          v-icon mdi-chevron-left
        v-list-item-content
          v-list-item-title ..

    v-col(cols=12, md=6, lg=4, xl=3,
      v-for="file in files.slice().sort((x, y) => (y.new - x.new) || (!!(y.new_items||0) - !!(x.new_items||0)))",
      v-if="file.type=='dir'", :key="`list-${file.name}`")
      v-list-item(:to="path+file.name")
        v-list-item-icon
          v-badge(overlap)
            template(v-slot:badge, v-if="file.new") !
            template(v-slot:badge, v-else-if="file.new_items") {{file.new_items}}
            v-icon mdi-folder
        v-list-item-content
          v-list-item-title {{file.name}}
        v-list-item-action.ma-0
          v-icon mdi-chevron-right

    v-col(cols=12, md=6, lg=4, xl=3,
      v-else-if="file.type=='png'", :key="`list-${file.name}`")
      v-list-item(:href="file.link", target="_blank")
        v-badge(overlap)
          template(v-slot:badge, v-if="file.new") !
          v-img.my-1.mr-2(:src="file.icon", max-height=48, max-width=48, contain, style="width: 48px; height: 48px; margin: auto")
        v-list-item-content
          v-list-item-title {{file.name}}.png

    v-col(cols=12, md=6, lg=4, xl=3,
      v-else-if="file.type=='json'", :key="`list-${file.name}`")
      v-list-item(:href="file.link", target="_blank")
        v-list-item-icon
          v-badge(overlap)
            template(v-slot:badge, v-if="file.new") !
            v-icon mdi-json
        v-list-item-content
          v-list-item-title {{file.name}}.json
        v-list-item-action.ma-0(v-if="file.csv")
          v-btn(icon, :href="file.csv", target="_blank")
            v-icon mdi-table

    v-col(cols=12, md=6, lg=4, xl=3,
      v-else-if="file.type=='mp3'", :key="`list-${file.name}`")
      v-list-item(:href="file.link", target="_blank")
        v-list-item-icon
          v-badge(overlap)
            template(v-slot:badge, v-if="file.new") !
            v-icon mdi-music
        v-list-item-content
          v-list-item-title {{file.name}}.mp3

    v-col(cols=12, md=6, lg=4, xl=3, v-else, :key="file")
      v-list-item(:href="file.link", target="_blank")
        v-list-item-content
          v-list-item-title {{file}}
</template>

<script>
export default {
  name: 'ListView',
  props: ['files', 'error'],
  computed: {
    path() {
      const p = this.$route.path;
      if (p.endsWith('/')) {
        return p;
      }
      return p + '/';
    },
    back() {
      return this.path.split('/').slice(0, -2).join('/') + '/';
    },
  },
};
</script>